local nkRebuffInfo, nkRebuff = ...

nkRebuff.Config = { 
	selectedBar = 1,
	cbTemplate = {labelinfront = true, labelwidth = 175, fontsize = 13, color = {border = 'ECE4BD', body = '000000', label = 'ECE4BD' }},
	comboTemplate = { color = {border = '666666', body = '000000', label = 'ECE4BD'}, width = 150, fontsize = 13, height = 19 },
	textTemplate = { color = 'ECE4BD', fontsize = 13},
	textHeaderTemplate = { color = 'FFFFFF', fontsize = 16},
	textHeaderShadowTemplate = { color = '000000', fontsize = 16},
	fldTemplate = { width = 40, height = 20, fontsize = 13, labelwidth = 100, color = { label = 'ECE4BD', border = '666666', body = '000000', focus = '999999' } }
}

function nkRebuff.Config:new(settings)
	
	local this = settings or {}
	
	self:CreateUI()	
	
	setmetatable(this, self)
	self.__index = self
	return this
 
end

function nkRebuff.Config:Show(flag) 
	
	if flag == true then self:Update() end
	self.frame:SetVisible(flag) 
	
end

function nkRebuff.Config:Update()

	if self.frame.paneTabSettings.paneTrack.selSetting ~= nil then
		local selection = self.frame.paneTabSettings.paneTrack.selSetting:getValue()
		if selection == 1 then
			self:PopulateGrid(self.frame.paneTabSettings.paneTrack, 'buffdura', self.frame.paneTabSettings.paneTrack.cbActiveOnly:getChecked(), self.frame.paneTabSettings.paneTrack.cbUseableOnly:getChecked())
		elseif selection == 2 then
			self:PopulateGrid(self.frame.paneTabSettings.paneTrack, 'buffperma', self.frame.paneTabSettings.paneTrack.cbActiveOnly:getChecked(), self.frame.paneTabSettings.paneTrack.cbUseableOnly:getChecked())
		elseif selection == 3 then
			self:PopulateGrid(self.frame.paneTabSettings.paneTrack, 'buffother', self.frame.paneTabSettings.paneTrack.cbActiveOnly:getChecked(), self.frame.paneTabSettings.paneTrack.cbUseableOnly:getChecked())
		elseif selection == 4 then
			self:PopulateGrid(self.frame.paneTabSettings.paneTrack, 'buff3rd', self.frame.paneTabSettings.paneTrack.cbActiveOnly:getChecked(), self.frame.paneTabSettings.paneTrack.cbUseableOnly:getChecked())
		elseif selection == 5 then
			self:PopulateGrid(self.frame.paneTabSettings.paneTrack, 'debuff', self.frame.paneTabSettings.paneTrack.cbActiveOnly:getChecked(), self.frame.paneTabSettings.paneTrack.cbUseableOnly:getChecked())
		elseif selection == 6 then
			self:PopulateGrid(self.frame.paneTabSettings.paneTrack, 'cooldowns', self.frame.paneTabSettings.paneTrack.cbActiveOnly:getChecked(), self.frame.paneTabSettings.paneTrack.cbUseableOnly:getChecked())
		elseif selection == 7 then
			self:PopulateGrid(self.frame.paneTabSettings.paneTrack, 'debuff3rd', self.frame.paneTabSettings.paneTrack.cbActiveOnly:getChecked(), self.frame.paneTabSettings.paneTrack.cbUseableOnly:getChecked())
		elseif selection == 8 then
			self:PopulateGrid(self.frame.paneTabSettings.paneTrack, 'buffTarget', self.frame.paneTabSettings.paneTrack.cbActiveOnly:getChecked(), self.frame.paneTabSettings.paneTrack.cbUseableOnly:getChecked())
		end
	end

	self:updateSetSelection(self.frame.paneTabSettings.paneGeneric)
	self.frame.paneTabSettings.paneGeneric.fldSelRole:setByValue (nkRBSetup.sets[nkRBSetup.basic.activeSet].role)
		
	self:udpateTabSettings_Bar(1, self.frame.paneTabSettings.paneBarBuff)
	self:udpateTabSettings_Bar(2, self.frame.paneTabSettings.paneBarDebuffTarget)
	self:udpateTabSettings_Bar(3, self.frame.paneTabSettings.paneBarDebuffPlayer)
	self:udpateTabSettings_Bar(4, self.frame.paneTabSettings.paneBarBuffCooldown)
	self:udpateTabSettings_Bar(5, self.frame.paneTabSettings.paneBarBuffActive)
	self:udpateTabSettings_Bar(6, self.frame.paneTabSettings.paneBarWarning)
	self:udpateTabSettings_Bar(7, self.frame.paneTabSettings.paneBarBuffTarget)
		
end

function nkRebuff.Config:Close() 
	
	if self.frame.paneTabSettings.paneGeneric.fldSetName ~= nil then
		self.frame.paneTabSettings.paneGeneric.fldSetName:leave()	
		self.frame.paneTabSettings.paneGeneric.fldSetName:SetVisible(false)
		self.frame.paneTabSettings.paneGeneric.fldSelSet:SetVisible(true)	
	end
	
	if self.frame.paneTabSettings.paneTrack.fldSearch ~= nil then
		self.frame.paneTabSettings.paneTrack.fldSearch:leave()	
	end	
	
	self.frame.paneTabSettings.paneGeneric.cbLocked:toggle(true)
	self:Move(true)
	
	self:Show(false)
	
	nkRebuff.performanceCheck()
	nkRebuff.buildBars()
	nkRebuff.updateBars()
	
	if nkRBSetup.basic.doRecognition == true and nkRebuff.privateVars.brEventInit == false then 
		table.insert(Event.Buff.Add, {nkRebuff.events.BuffAdd , "nkRebuff", "buffAdded"}) 
		table.insert(Event.Ability.Cooldown.Begin, { nkRebuff.events.cooldownBegin, "nkRebuff", "CDBegin"})
		nkRebuff.privateVars.brEventInit = true
	end
	
	if nkRBSetup.basic.autoRoleSwitch == true and nkRebuff.privateVars.brRoleChangeInit == false then 
		table.insert(Event.Unit.Detail.Role	, {nkRebuff.events.roleChange, "nkRebuff", "roleChange"})
		nkRebuff.privateVars.brRoleChangeInit = true
	end
	
end

-- UI creation

function nkRebuff.Config:CreateUI()

	self.frame = UI.CreateFrame ('nkExtRiftWindow', 'configFrame', nkRebuff.UIelements.configContext, { layer = 1, width = 960, height = 600, title = nkRebuff.privateVars.addonName .. ' V' .. nkRebuff.privateVars.addonVersion, anchors = {{from = "CENTER", object = UIParent, to = "CENTER"}}, dragable = true, closeable = true, visible = true, closeFunc = function() self:Close() end})

	self.frame.paneTabSettings = UI.CreateFrame ('nkExtFrame', 'configFrameTab1', self.frame:getBody(true), { visible = false})
	self.frame.paneTabAbout = UI.CreateFrame ('nkExtFrame', 'configFrameTab2', self.frame:getBody(true), { visible = false})
	
	self.frame.tabPane = UI.CreateFrame ('nkExtTabPane', 'configFrameTabPane', self.frame:getBody(), { fontsize = 14, width = 910, height = 512.5,  color = { body = "444444" , border = "000000" , label= "FFFFFF", inactive = "333333"}, 
											anchors = {{from = "TOPLEFT", object = self.frame:getBody(), to = "TOPLEFT", x = 10, y = 10}}, orientation = 'horizontal',
											headerWidth = 113, headerHeight = 28, headerOffsetX = 10, headerOffSetY = 0,
											bodyTexture = 'gfx/nkRebuffTabPaneBG.png',
											paneTextureAddon = 'nkRebuff',	paneTextureInactive = 'gfx/tabPaneHorizInActive.png', paneTextureActive = 'gfx/tabPaneHorizActive.png',							
											panes = {{content = self.frame.paneTabSettings, label = nkRebuff.langTexts.basicUI.tabHeader1, initFunc = function () self:setupTabSettings() end},
													 {content = self.frame.paneTabAbout, label = nkRebuff.langTexts.basicUI.tabHeader2, initFunc = function () self:SetupTabAbout() end}											
											}
											})

end

function nkRebuff.Config:setupTabSettings()

	local parent = self.frame.paneTabSettings

	parent.paneGeneric = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneGeneric', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	parent.paneBarWarning = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneBarWarning', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	parent.paneBarBuff = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneBar1', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	parent.paneBarBuffTarget = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneBar2', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	parent.paneBarDebuffTarget = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneBar3', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	parent.paneBarDebuffPlayer = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneBar4', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	parent.paneBarBuffCooldown = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneBar5', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	parent.paneBarBuffActive = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneBar6', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	parent.paneTrack = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneTrack', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	parent.paneDebuffList = UI.CreateFrame('nkExtFrame', 'nkRBSetupTabPaneDebuffList', parent:getElement(), { anchors = {{ from = "TOPLEFT", object = parent:getElement(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT" }} })
	
	parent.tabPane = UI.CreateFrame ('nkExtTabPane', 'nkRBSetupTabPane', parent:getElement(true), { fontsize = 14, width = 887, height = 400,  color = { body = "444444" , border = "000000" , label= "ECE4BD", inactive = "333333"}, 
											orientation = 'vertical', headerWidth = 150, headerHeight = 25, headerTexture = 'gfx/nkRebuffTabPaneILeftBG.png', headerTextureWidth = 172, headerTextureHeight = 400, headerOffsetX = 11, headerOffsetY = 8, 
											bodyTexture = 'gfx/nkRebuffConfigSettingsBG.png', bodyOffsetX = 2, bodyOffsetY = 0,
											paneTextureAddon = 'nkRebuff', paneTextureInactive = 'gfx/tabPaneVertInActive.png', paneTextureActive = 'gfx/tabPaneVertActive.png',
											anchors = {{from = "TOPLEFT", object = parent:getElement(true), to = "TOPLEFT", x = 10, y = 35}}, 
											panes = {	{content = parent.paneGeneric, label = nkRebuff.langTexts.settingsTab.generic, initFunc = function () self:setupTabSettings_Generic(parent.paneGeneric) end },														
														{content = parent.paneBarWarning, label = nkRebuff.langTexts.settingsTab.barWarning, initFunc = function () self:setupTabSettings_Bar(nkRebuff.const.barWarningsID, parent.paneBarWarning) end },
														{content = parent.paneBarBuff, label = nkRebuff.langTexts.settingsTab.barBuff, initFunc = function () self:setupTabSettings_Bar(nkRebuff.const.barBuffsID, parent.paneBarBuff) end },
														{content = parent.paneBarBuffTarget, label = nkRebuff.langTexts.settingsTab.barBuffTarget, initFunc = function () self:setupTabSettings_Bar(nkRebuff.const.barbuffTargetID, parent.paneBarBuffTarget) end },
														{content = parent.paneBarDebuffTarget, label = nkRebuff.langTexts.settingsTab.barDebuffTarget, initFunc = function () self:setupTabSettings_Bar(nkRebuff.const.barDebuffsID, parent.paneBarDebuffTarget) end },
														{content = parent.paneBarDebuffPlayer, label = nkRebuff.langTexts.settingsTab.barDebuffPlayer, initFunc = function () self:setupTabSettings_Bar(nkRebuff.const.barDebuffsPlayerID, parent.paneBarDebuffPlayer) end },
														{content = parent.paneBarBuffCooldown, label = nkRebuff.langTexts.settingsTab.barCooldown, initFunc = function () self:setupTabSettings_Bar(nkRebuff.const.barCooldownsID, parent.paneBarBuffCooldown) end },
														{content = parent.paneBarBuffActive, label = nkRebuff.langTexts.settingsTab.barActive, initFunc = function () self:setupTabSettings_Bar(nkRebuff.const.barAbilitiesID, parent.paneBarBuffActive) end },
														{content = parent.paneTrack, label = nkRebuff.langTexts.settingsTab.track, initFunc = function () self:setupTabSettings_Track(parent.paneTrack) end },
														{content = parent.paneDebuffList, label = nkRebuff.langTexts.settingsTab.debuffList, initFunc = function () self:setupTabSettings_DebuffList(parent.paneDebuffList) end}
											}
										})	
	
	parent.closeButton = UI.CreateFrame ('nkExtRiftButton', 'configFrameButtonClose', self.frame:getElement(), { label = nkRebuff.langTexts.basicUI.btClose, anchors = {{from = "BOTTOMLEFT", object = parent:getElement(), to = "BOTTOMLEFT", x = 10, y = -5}}, func = function () self:Close() end})	
	parent.resetHiddenButton = UI.CreateFrame ('nkExtRiftButton', 'configFrameButtonResetHidden', self.frame:getElement(), { label = nkRebuff.langTexts.basicUI.btResetHidden, anchors = {{from = "TOPLEFT", object = parent.closeButton:getElement(), to = "TOPRIGHT", x = 10, y = 0}}, func = function () nkRebuff.clearTempHides() end})	
	parent.resetDataButton = UI.CreateFrame ('nkExtRiftButton', 'configFrameButtonResetData', self.frame:getElement(), { label = nkRebuff.langTexts.basicUI.btResetData, anchors = {{from = "TOPLEFT", object = parent.resetHiddenButton:getElement(), to = "TOPRIGHT", x = 10, y = 0}}, func = function () self:ClearData() end})	
	
	parent.exportBarSetup = UI.CreateFrame ('nkExtRiftButton', 'configFrameButtonExportBarSetup', self.frame:getElement(), { label = nkRebuff.langTexts.basicUI.btExportBarSetup, anchors = {{from = "TOPLEFT", object = parent.resetDataButton:getElement(), to = "TOPRIGHT", x = 10, y = 0}}, func = function () self:ExportBarSetup() end})	
	parent.importBarSetup = UI.CreateFrame ('nkExtRiftButton', 'configFrameButtonImportBarSetup', self.frame:getElement(), { label = nkRebuff.langTexts.basicUI.btImportBarSetup, anchors = {{from = "TOPLEFT", object = parent.exportBarSetup:getElement(), to = "TOPRIGHT", x = 10, y = 0}}, func = function () self:ImportBarSetup() end})	

	parent.donateButton = UI.CreateFrame ('nkExtRiftButton', 'configFrameButtonDonate', self.frame:getBody(true), { layer = 9, label = nkRebuff.langTexts.basicUI.btDonate, anchors = {{from = "BOTTOMRIGHT", object = parent:getElement(), to = "BOTTOMRIGHT", x = -10, y = -5}}, func = function () self:donateInfo() end})
	
end

function nkRebuff.Config:setupTabSettings_Generic(frame)

	if nkTools.various.getSystemVersion() == '109' then Command.System.Watchdog.Quiet() end
	
	frame.labelBasicShadow = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneGenericlabelBasicShadow', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.basic, anchors = {{ from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 12, y = 12}}, template = nkRebuff.Config.textHeaderShadowTemplate })
	frame.labelBasic = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneGenericlabelBasic', frame.labelBasicShadow:getElement(), { text = nkRebuff.langTexts.genericSettings.basic, anchors = {{ from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 10, y = 10}}, template = nkRebuff.Config.textHeaderTemplate })

	frame.cbActive = UI.CreateFrame('nkExtCheckbox', 'cbActive', frame:getElement(), {text = nkRebuff.langTexts.genericSettings.active, checked = nkRBSetup.basic.active, 
														anchors = {{from = "TOPLEFT", object = frame.labelBasic:getElement(), to = "BOTTOMLEFT",x= 0, y= 5 }}, template = nkRebuff.Config.cbTemplate,
														func = function (this) nkRBSetup.basic.active = this:getChecked(); if nkRebuff.buffBar ~= nil then nkRebuff.buffBar:SetVisible(nkRBSetup.basic.active) end end})

	frame.cbLocked = UI.CreateFrame('nkExtCheckbox', 'cbLocked', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.locked, checked = nkRBSetup.basic.locked,
														anchors = {{from = "TOPLEFT", object = frame.cbActive:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template = nkRebuff.Config.cbTemplate,
														func = function (this) nkRBSetup.basic.locked = this:getChecked(); self:Move() end })

	frame.cbShowBarsDuringConfig = UI.CreateFrame('nkExtCheckbox', 'cbShowBarsDuringConfig', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.showBarsDuringConfig, checked = nkRBSetup.basic.showBarsDuringConfig,
														anchors = {{from = "TOPLEFT", object = frame.cbLocked:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template = nkRebuff.Config.cbTemplate,
														func = function (this) nkRBSetup.basic.showBarsDuringConfig = this:getChecked() end })
														
	frame.labelFunctionsShadow = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneGenericlabelFunctionsShadow', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.functions, anchors = {{ from = "TOPLEFT", object = frame.cbShowBarsDuringConfig:getElement(), to = "BOTTOMLEFT", x = 0, y = 17}}, template = nkRebuff.Config.textHeaderShadowTemplate })
	frame.labelFunctions = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneGenericlabelFunctions', frame.labelFunctionsShadow:getElement(), { text = nkRebuff.langTexts.genericSettings.functions, anchors = {{ from = "TOPLEFT", object = frame.cbShowBarsDuringConfig:getElement(), to = "BOTTOMLEFT", x = 0, y = 15}}, template = nkRebuff.Config.textHeaderTemplate })

	frame.cbCombat = UI.CreateFrame('nkExtCheckbox', 'cbCombat', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.cbCombat, checked = nkRBSetup.basic.combatOnly, 
														anchors = {{from = "TOPLEFT", object = frame.labelFunctions:getElement(), to = "BOTTOMLEFT", x= 0, y= 5}}, template = nkRebuff.Config.cbTemplate,														
														func = function (this) nkRBSetup.basic.combatOnly = this:getChecked() end})													
														
	frame.cbAutoSwitch = UI.CreateFrame('nkExtCheckbox', 'cbAutoSwitch', frame:getElement(), { checked = nkRBSetup.basic.autoRoleSwitch, text = nkRebuff.langTexts.genericSettings.roleSwitch,
																								anchors = {{from = "TOPLEFT", object = frame.cbCombat:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template = nkRebuff.Config.cbTemplate,
																								func = function (this) nkRBSetup.basic.autoRoleSwitch = this:getChecked() end})

	frame.cbRemainingWarning = UI.CreateFrame('nkExtCheckbox', 'cbRemainingWarning', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.cbRemainingWarning, checked = nkRBSetup.basic.remainingWarning,
														anchors = {{from = "TOPLEFT", object = frame.cbAutoSwitch:getElement(), to = "BOTTOMLEFT", x= 0, y= 10}}, template = nkRebuff.Config.cbTemplate,														
														func = function (this) nkRBSetup.basic.remainingWarning = this:getChecked() end })
														
	frame.cbDebuffWarning = UI.CreateFrame('nkExtCheckbox', 'cbDebuffWarning', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.cbDebuffWarning, checked = nkRBSetup.basic.debuffWarning,
														anchors = {{from = "TOPLEFT", object = frame.cbRemainingWarning:getElement(), to = "BOTTOMLEFT", x= 0, y= 10}}, template = nkRebuff.Config.cbTemplate,														
														func = function (this) nkRBSetup.basic.debuffWarning = this:getChecked(); self:Move() end })
	
	frame.cbNewDebuffActive = UI.CreateFrame('nkExtCheckbox', 'cbNewDebuffActive', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.cbNewDebuffActive, checked = nkRBSetup.basic.newDebuffActive,
														anchors = {{from = "TOPLEFT", object = frame.cbDebuffWarning:getElement(), to = "BOTTOMLEFT", x= 0, y= 10}}, template = nkRebuff.Config.cbTemplate,														
														func = function (this) nkRBSetup.basic.newDebuffActive = this:getChecked(); self:Move() end })

	frame.slGCD = UI.CreateFrame('nkExtSlider', 'slGCD', frame:getElement(), {text = string.format(nkRebuff.langTexts.genericSettings.slGCD, nkRBSetup.basic.gcd), value = nkRBSetup.basic.gcd, range = {0.1, 1.5}, width = 100, 
															precision = 1, anchors = {{from = "TOPLEFT", object = frame.cbCombat:getElement(), to = "TOPLEFT", x= 320, y = 0}},  template = nkRebuff.Config.cbTemplate, 
															func = function(this) nkRBSetup.basic.gcd = this.value; this:update({ text = string.format(nkRebuff.langTexts.genericSettings.slGCD, nkRBSetup.basic.gcd) }) end })

	frame.labelPerformanceShadow = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneGenericlabelPerformanceShadow', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.performance, anchors = {{ from = "TOPLEFT", object = frame.cbNewDebuffActive:getElement(), to = "BOTTOMLEFT", x = 0, y = 17}}, template = nkRebuff.Config.textHeaderShadowTemplate })
	frame.labelPerformance = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneGenericlabelPerformance', frame.labelPerformanceShadow:getElement(), { text = nkRebuff.langTexts.genericSettings.performance, anchors = {{ from = "TOPLEFT", object = frame.cbNewDebuffActive:getElement(), to = "BOTTOMLEFT", x = 0, y = 15}}, template = nkRebuff.Config.textHeaderTemplate })

	frame.cbEvents = UI.CreateFrame('nkExtCheckbox', 'cbEvents', frame:getElement(), {text = nkRebuff.langTexts.genericSettings.cbEvents, checked = nkRBSetup.basic.doRecognition, 
														anchors = {{from = "TOPLEFT", object = frame.labelPerformance:getElement(true), to = "BOTTOMLEFT", x = 0, y = 5}}, template = nkRebuff.Config.cbTemplate,
														func = function (this) self:ActivateEvent(this:getChecked()) end})														
	
	frame.slThrottle = UI.CreateFrame('nkExtSlider', 'slThrottle', frame:getElement(), {text = string.format(nkRebuff.langTexts.genericSettings.slThrottle, nkRBSetup.basic.throttle), value = nkRBSetup.basic.throttle, range = {0.1, 1}, width = 100, 
															precision = 1, anchors = {{from = "TOPLEFT", object = frame.cbEvents:getElement(), to = "BOTTOMLEFT", x= 0, y= 10}},  template = nkRebuff.Config.cbTemplate, 
															func = function(this) nkRBSetup.basic.throttle = this.value; this:update({ text = string.format(nkRebuff.langTexts.genericSettings.slThrottle, nkRBSetup.basic.throttle) }) end })

	frame.slCounterCorr = UI.CreateFrame('nkExtSlider', 'slThrottle', frame:getElement(), {text = string.format(nkRebuff.langTexts.genericSettings.slCounterCorr, nkRBSetup.basic.counterCorrection), value = nkRBSetup.basic.counterCorrection, range = {-1, 1}, width = 100, 
															precision = 1, anchors = {{from = "TOPLEFT", object = frame.slThrottle:getElement(), to = "BOTTOMLEFT", x= 0, y= 10}},  template = nkRebuff.Config.cbTemplate, 
															func = function(this) nkRBSetup.basic.counterCorrection = this.value; this:update({ text = string.format(nkRebuff.langTexts.genericSettings.slCounterCorr, nkRBSetup.basic.counterCorrection) }) end })
																
	frame.labelSetsShadow = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneGenericlabelSetsShadow', frame:getElement(), { text = nkRebuff.langTexts.genericSettings.sets, anchors = {{ from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 332, y = 12}}, template = nkRebuff.Config.textHeaderShadowTemplate })
	frame.labelSets = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneGenericlabelSets', frame.labelSetsShadow:getElement(), { text = nkRebuff.langTexts.genericSettings.sets, anchors = {{ from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 330, y = 12}}, template = nkRebuff.Config.textHeaderTemplate })
	
	local selection = {}
	
	for idx = 1, #nkRBSetup.sets, 1 do
		table.insert (selection, { label = nkRBSetup.sets[idx].name, value = idx })		
	end
	
	frame.setSetLabel = UI.CreateFrame ('nkExtText', 'setSetLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.labelSets:getElement(true), to = "BOTTOMLEFT", x = 0, y = 5 }}, text = nkRebuff.langTexts.genericSettings.currentSet, template = nkRebuff.Config.textTemplate })
	
	frame.fldSelSet = UI.CreateFrame('nkExtCombo', 'fldSelESet', frame:getElement(), {	layer = 3, value = 1, width = 200, template = nkRebuff.Config.comboTemplate, selection = selection,
																						anchors = {{ from = "CENTERLEFT", object = frame.setSetLabel:getElement(), to = "CENTERLEFT", x = 150, y = 0 }}, 
																						func = function (value) nkRebuff.activateSet(value) end })
	
	frame.editIcon = UI.CreateFrame('nkExtTexture', 'editIcon', frame:getElement(), { type = "nkRebuff", path = "gfx/editPen.png", width = 15, height = 15, anchors = {{ from = "CENTERLEFT", object = frame.fldSelSet:getElement(), to = "CENTERRIGHT", x = 5, y = 0 }} })
	
	frame.editIcon:SetEvent('LeftClick', function ()
		if frame.fldSetName:GetVisible() == true then
			frame.fldSetName:leave()
			frame.fldSelSet:SetVisible(true)
			frame.fldSetName:SetVisible(false)
		else			
			frame.fldSetName:setValue(nkRBSetup.sets[frame.fldSelSet:getValue()].name)
			frame.fldSelSet:SetVisible(false)
			frame.fldSetName:SetVisible(true)
		end
	end)
		
	frame.fldSetName = UI.CreateFrame ('nkExtTextField', 'fldSetName', frame:getElement(), {	layer = 2, visible = false, width = 200, value = nkRBSetup.sets[1].name, anchors = {{ from = "TOPLEFT", object = frame.fldSelSet:getElement(), to = "TOPLEFT" }}, 
																								func = function (value) nkRBSetup.sets[frame.fldSelSet:getValue()].name = value; self:updateSetSelection(frame) end, template = nkRebuff.Config.fldTemplate})	
	
	frame.setRoleLabel = UI.CreateFrame ('nkExtText', 'setRoleLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.setSetLabel:getElement(true), to = "BOTTOMLEFT", x = 0, y = 10 }}, text = nkRebuff.langTexts.genericSettings.role, template = nkRebuff.Config.textTemplate })
	
	frame.fldSelRole = UI.CreateFrame('nkExtCombo', 'fldSelRole', frame:getElement(), {	layer = 2, value = nkRBSetup.sets[nkRBSetup.basic.activeSet].role, width = 200, template = nkRebuff.Config.comboTemplate, selection = nkRebuff.langTexts.genericSettings.selectionRole,
																						anchors = {{ from = "CENTERLEFT", object = frame.setRoleLabel:getElement(), to = "CENTERLEFT", x = 150, y = 0 }}, 
																						func = function (value) nkRBSetup.sets[nkRBSetup.basic.activeSet].role = value end })
																						
	frame.btCopySet = UI.CreateFrame ('nkExtRiftButton', 'btCopySet', frame:getElement(), { layer = 1, label = nkRebuff.langTexts.genericSettings.btCopySet, anchors = {{from = "TOPRIGHT", object = frame.editIcon:getElement(), to = "BOTTOMRIGHT", x = 5, y = 40}}, func = function () self:copySet() end})	
	frame.btRemoveSet = UI.CreateFrame ('nkExtRiftButton', 'btRemoveSet', frame:getElement(), { layer = 1, label = nkRebuff.langTexts.genericSettings.btRemoveSet, anchors = {{from = "CENTERRIGHT", object = frame.btCopySet:getElement(), to = "CENTERLEFT", x = 5, y = 0}}, func = function () self:removeSet() end})		
	frame.btAddSet = UI.CreateFrame ('nkExtRiftButton', 'btAddSet', frame:getElement(), { layer = 1, label = nkRebuff.langTexts.genericSettings.btAddSet, anchors = {{from = "CENTERRIGHT", object = frame.btRemoveSet:getElement(), to = "CENTERLEFT", x = 5, y = 0}}, func = function () self:addSet() end})
	
	
	return frame

end

function nkRebuff.Config:setupTabSettings_Bar(barIndex, frame)

	if nkTools.various.getSystemVersion() == '109' then Command.System.Watchdog.Quiet() end
	
	frame.labelBasicShadow = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneBar' .. barIndex .. 'labelBasicShadow', frame:getElement(), { text = nkRebuff.langTexts.barSettings.basic, anchors = {{ from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 12, y = 12}}, template = nkRebuff.Config.textHeaderShadowTemplate })
	frame.labelBasic = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneBar' .. barIndex .. 'labelBasic', frame.labelBasicShadow:getElement(), { text = nkRebuff.langTexts.barSettings.basic, anchors = {{ from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 10, y = 10}}, template = nkRebuff.Config.textHeaderTemplate })
	
	frame.slnoOfIcons = UI.CreateFrame('nkExtSlider', 'slnoOfIcons', frame:getElement(), {text = nkRebuff.langTexts.barSettings.slnoOfIcons .. ' ' .. tostring(nkRBSetup.bars[barIndex].noOfIcons), value = nkRBSetup.bars[barIndex].noOfIcons, range = {3, 15}, width = 100, 
															anchors = {{from = "TOPLEFT", object = frame.labelBasic:getElement(), to = "BOTTOMLEFT", x= 0, y= 5}},  template = nkRebuff.Config.cbTemplate, 
															func = function(this) nkRBSetup.bars[barIndex].noOfIcons = math.floor(this.value); this:update({ text = nkRebuff.langTexts.barSettings.slnoOfIcons .. ' ' .. tostring(nkRBSetup.bars[barIndex].noOfIcons) }) end })
	
	frame.slRunoutDuration = UI.CreateFrame('nkExtSlider', 'slRunOutDuration', frame:getElement(), {text = string.format (nkRebuff.langTexts.barSettings.slRunoutDuration, nkRBSetup.bars[barIndex].runoutDuration), value = nkRBSetup.bars[barIndex].runoutDuration, range = {0, 60}, width = 100, 
																anchors = {{from = "TOPLEFT", object = frame.labelBasic:getElement(), to = "BOTTOMLEFT", x=350, y=5}}, template =nkRebuff.Config.cbTemplate,
																func = function (this) nkRBSetup.bars[barIndex].runoutDuration = this.value; this:update({ text = string.format (nkRebuff.langTexts.barSettings.slRunoutDuration, nkRBSetup.bars[barIndex].runoutDuration)}) end })

	frame.cbTooltip = UI.CreateFrame('nkExtCheckbox', 'cbFadein', frame:getElement(), {	text = nkRebuff.langTexts.barSettings.tooltip, checked = nkRBSetup.bars[barIndex].tooltip,
																						anchors = {{from = "TOPLEFT", object = frame.slnoOfIcons:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template =nkRebuff.Config.cbTemplate,
																						func = function (this) nkRBSetup.bars[barIndex].tooltip = this:getChecked(); end })

	frame.cbInteract = UI.CreateFrame('nkExtCheckbox', 'cbFadein', frame:getElement(), {	text = nkRebuff.langTexts.barSettings.hideOnLeftClick, checked = nkRBSetup.bars[barIndex].hideOnLeftClick,
																						anchors = {{from = "TOPLEFT", object = frame.slnoOfIcons:getElement(), to = "BOTTOMLEFT", x = 350, y = 10}}, template =nkRebuff.Config.cbTemplate,
																						func = function (this) nkRBSetup.bars[barIndex].hideOnLeftClick = this:getChecked(); end })
																
	frame.labelDesignShadow = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneBar' .. barIndex .. 'labelDesignShadow', frame:getElement(), { text = nkRebuff.langTexts.barSettings.design, anchors = {{ from = "TOPLEFT", object = frame.cbTooltip:getElement(), to = "BOTTOMLEFT", x = 2, y = 17}}, template = nkRebuff.Config.textHeaderShadowTemplate })
	frame.labelDesign = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneBar' .. barIndex .. 'labelDesign', frame.labelDesignShadow:getElement(), { text = nkRebuff.langTexts.barSettings.design, anchors = {{ from = "TOPLEFT", object = frame.cbTooltip:getElement(), to = "BOTTOMLEFT", x = 0, y = 15}}, template = nkRebuff.Config.textHeaderTemplate })	
	
	frame.slScale = UI.CreateFrame('nkExtSlider', 'slScale', frame:getElement(), {text = nkRebuff.langTexts.barSettings.slScale .. ' ' .. tostring(nkRBSetup.bars[barIndex].scale) .. '%', value = nkRBSetup.bars[barIndex].scale, range = {1, 200}, width = 100, 
															anchors = {{from = "TOPLEFT", object = frame.labelDesign:getElement(), to = "BOTTOMLEFT", x = 0, y = 5}}, template =nkRebuff.Config.cbTemplate,
															func = function(this) nkRBSetup.bars[barIndex].scale = this.value; this:update({ text = nkRebuff.langTexts.barSettings.slScale .. ' ' .. tostring(nkRBSetup.bars[barIndex].scale) .. '%' }); if nkRebuff.buffBar ~= nil then nkRebuff.buffBar:Update() end end })
	
	frame.selAlignLabel = UI.CreateFrame ('nkExtText', 'selAlignLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.labelDesign:getElement(), to = "BOTTOMLEFT", x = 350, y = 5 }}, text = nkRebuff.langTexts.barSettings.rbAlign, template = nkRebuff.Config.textTemplate })	
			
	frame.selAlign = UI.CreateFrame('nkExtCombo', 'selAlign', frame:getElement(), { layer = 6, value = nkRBSetup.bars[barIndex].align, selection = nkRebuff.langTexts.barSettings.alignSelection, anchors = {{from = "TOPLEFT", object = frame.selAlignLabel:getElement(), to = "TOPLEFT", x = 178, y = 0 }}, template =nkRebuff.Config.comboTemplate, 
														func = function (value) nkRBSetup.bars[barIndex].align = value end})


	frame.cbFadein = UI.CreateFrame('nkExtCheckbox', 'cbFadein', frame:getElement(), { text = nkRebuff.langTexts.barSettings.cbFadein, checked = nkRBSetup.bars[barIndex].cbFadein,
														anchors = {{from = "TOPLEFT", object = frame.slScale:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template =nkRebuff.Config.cbTemplate,
														func = function (this) nkRBSetup.bars[barIndex].cbFadein = this:getChecked(); end })													
	
	frame.slAlpha = UI.CreateFrame('nkExtSlider', 'slAlpha', frame:getElement(), {text = nkRebuff.langTexts.barSettings.slAlpha .. ' ' .. tostring(nkRBSetup.bars[barIndex].alpha), value = nkRBSetup.bars[barIndex].alpha * 10, range = {2, 10}, width = 100, 
															anchors = {{from = "TOPLEFT", object = frame.slScale:getElement(), to = "BOTTOMLEFT", x= 350, y = 10}}, labelwidth = 174, template =nkRebuff.Config.cbTemplate, 
															func = function(this) nkRBSetup.bars[barIndex].alpha = this.value/10; this:update({ text = nkRebuff.langTexts.barSettings.slAlpha .. ' ' .. tostring(nkRBSetup.bars[barIndex].alpha) }) end })

	frame.selBorderLabel = UI.CreateFrame ('nkExtText', 'selBorderLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.cbFadein:getElement(), to = "BOTTOMLEFT", x = 0, y = 9 }}, text = nkRebuff.langTexts.barSettings.border, template = nkRebuff.Config.textTemplate })				
	frame.selBorder = UI.CreateFrame('nkExtCombo', 'selBorder', frame:getElement(), { layer = 5, value = nkRBSetup.bars[barIndex].border, selection = nkRebuff.langTexts.barSettings.borderSelection, anchors = {{from = "TOPLEFT", object = frame.selBorderLabel:getElement(), to = "TOPLEFT", x = 178, y = 0 }}, template =nkRebuff.Config.comboTemplate, 
														func = function (value) nkRBSetup.bars[barIndex].border = value end})

	frame.selColorBorderLabel = UI.CreateFrame ('nkExtText', 'selColorBuffLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.cbFadein:getElement(), to = "BOTTOMLEFT", x = 350, y = 9 }}, text = nkRebuff.langTexts.barSettings.rbColorBorder, template = nkRebuff.Config.textTemplate })
	frame.selColorBorder = UI.CreateFrame('nkExtCombo', 'selColorBuff', frame:getElement(), {	layer = 5, value = nkRBSetup.bars[barIndex].bcolor, selection = nkRebuff.langTexts.barSettings.colorSelection, 
																								anchors = {{from = "CENTERLEFT", object = frame.selColorBorderLabel:getElement(), to = "CENTERLEFT", x = 178, y = 0 }}, 
																								template =nkRebuff.Config.comboTemplate, func = function (value) nkRBSetup.bars[barIndex].bcolor = value end})

	frame.selColorCounterLabel = UI.CreateFrame ('nkExtText', 'selColorCounterLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.selBorderLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 3 }}, text = nkRebuff.langTexts.barSettings.rbColorCounter, template = nkRebuff.Config.textTemplate })
	frame.selColorCounter = UI.CreateFrame('nkExtCombo', 'selColorCounter', frame:getElement(), { layer = 4, value = nkRBSetup.bars[barIndex].ccolor, selection = nkRebuff.langTexts.barSettings.colorSelection,
																								  anchors = {{from = "CENTERLEFT", object = frame.selColorCounterLabel:getElement(), to = "CENTERLEFT", x = 178, y = 0 }}, template =nkRebuff.Config.comboTemplate, 
																								func = function (value) nkRBSetup.bars[barIndex].ccolor = value end})																																																					
	
	frame.selPosCounterLabel = UI.CreateFrame ('nkExtText', 'selPosCounterLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.selBorderLabel:getElement(), to = "BOTTOMLEFT", x = 350, y = 5 }}, text = nkRebuff.langTexts.barSettings.txtPosition, template = nkRebuff.Config.textTemplate })	
	frame.selPosCounter = UI.CreateFrame('nkExtCombo', 'selPosCounter', frame:getElement(), {	layer = 4, value = nkRBSetup.bars[barIndex].counterPos, selection = nkRebuff.langTexts.barSettings.posSel, anchors = {{from = "TOPLEFT", object = frame.selPosCounterLabel:getElement(), to = "TOPLEFT", x = 178, y = 0 }}, template =nkRebuff.Config.comboTemplate, 
																									func = function (value) nkRBSetup.bars[barIndex].counterPos = value end})

	frame.slFontSizeCounter = UI.CreateFrame('nkExtSlider', 'slFontSizeStack', frame:getElement(), {text = nkRebuff.langTexts.barSettings.slCounterFontSize .. ' ' .. tostring(nkRBSetup.bars[barIndex].counterFontsize), value = nkRBSetup.bars[barIndex].counterFontsize, range = {10, 40}, width = 100, 
																						anchors = {{from = "TOPLEFT", object = frame.selColorCounterLabel:getElement(), to = "BOTTOMLEFT", x=0, y=5}}, labelwidth = 174, template =nkRebuff.Config.cbTemplate, 
																						func = function(this) nkRBSetup.bars[barIndex].counterFontsize = math.floor(this.value*10)/10; this:update({ text = nkRebuff.langTexts.barSettings.slCounterFontSize .. ' ' .. tostring(nkRBSetup.bars[barIndex].counterFontsize) }) end })
																									
	frame.selColorStackLabel = UI.CreateFrame ('nkExtText', 'selColorStackLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.slFontSizeCounter:getElement(), to = "BOTTOMLEFT", x = 0, y = 9 }}, text = nkRebuff.langTexts.barSettings.rbColorStack, template = nkRebuff.Config.textTemplate })
	frame.selColorStack = UI.CreateFrame('nkExtCombo', 'selColorStack', frame:getElement(), { layer = 3, value = nkRBSetup.bars[barIndex].stackColor, selection = nkRebuff.langTexts.barSettings.colorSelection,
																								  anchors = {{from = "CENTERLEFT", object = frame.selColorStackLabel:getElement(), to = "CENTERLEFT", x = 178, y = 0 }}, template = nkRebuff.Config.comboTemplate, 
																								func = function (value) nkRBSetup.bars[barIndex].stackColor = value end})																																																					

	frame.selPosStackLabel = UI.CreateFrame ('nkExtText', 'selPosStackLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.slFontSizeCounter:getElement(), to = "BOTTOMLEFT", x = 350, y = 5 }}, text = nkRebuff.langTexts.barSettings.txtPosition, template = nkRebuff.Config.textTemplate })	
	frame.selPosStack = UI.CreateFrame('nkExtCombo', 'selPosStack', frame:getElement(), {	layer = 3, value = nkRBSetup.bars[barIndex].stackPos, selection = nkRebuff.langTexts.barSettings.posSel, anchors = {{from = "TOPLEFT", object = frame.selPosStackLabel:getElement(), to = "TOPLEFT", x = 178, y = 0 }}, template =nkRebuff.Config.comboTemplate, 
																									func = function (value) nkRBSetup.bars[barIndex].stackPos = value end})

	frame.slFontSizeStack = UI.CreateFrame('nkExtSlider', 'slFontSizeStack', frame:getElement(), {text = nkRebuff.langTexts.barSettings.slStackFontSize .. ' ' .. tostring(nkRBSetup.bars[barIndex].stackFontsize), value = nkRBSetup.bars[barIndex].stackFontsize, range = {10, 40}, width = 100, 
																						anchors = {{from = "TOPLEFT", object = frame.selColorStackLabel:getElement(), to = "BOTTOMLEFT", x=0, y=5}}, labelwidth = 174, template =nkRebuff.Config.cbTemplate, 
																						func = function(this) nkRBSetup.bars[barIndex].stackFontsize = math.floor(this.value*10)/10; this:update({ text = nkRebuff.langTexts.barSettings.slStackFontSize .. ' ' .. tostring(nkRBSetup.bars[barIndex].stackFontsize) }) end })
																									
	frame.labelTextShadow = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneBar' .. barIndex .. 'labelTextShadow', frame:getElement(), { text = nkRebuff.langTexts.barSettings.texts, anchors = {{ from = "TOPLEFT", object = frame.slFontSizeStack:getElement(), to = "BOTTOMLEFT", x = 2, y = 17}}, template = nkRebuff.Config.textHeaderShadowTemplate })
	frame.labelText = UI.CreateFrame('nkExtText', 'nkRBSetupTabPaneBar' .. barIndex .. 'labelText', frame.labelTextShadow:getElement(), { text = nkRebuff.langTexts.barSettings.texts, anchors = {{ from = "TOPLEFT", object = frame.slFontSizeStack:getElement(), to = "BOTTOMLEFT", x = 0, y = 15}}, template = nkRebuff.Config.textHeaderTemplate })														

	frame.selLabelLabel = UI.CreateFrame ('nkExtText', 'selLabelLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.labelText:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }}, text = nkRebuff.langTexts.barSettings.label, template = nkRebuff.Config.textTemplate })				
	frame.selLabel = UI.CreateFrame('nkExtCombo', 'selLabel', frame:getElement(), { layer = 2, value = nkRBSetup.bars[barIndex].label, selection = nkRebuff.langTexts.barSettings.labelSelection, 
																					anchors = {{from = "TOPLEFT", object = frame.selLabelLabel:getElement(), to = "TOPLEFT", x = 178, y = 0 }}, template =nkRebuff.Config.comboTemplate, 
																					func = function (value) nkRBSetup.bars[barIndex].label = value end})
	
	frame.slFontSize = UI.CreateFrame('nkExtSlider', 'slFontSize', frame:getElement(), {text = nkRebuff.langTexts.barSettings.slFontSize .. ' ' .. tostring(nkRBSetup.bars[barIndex].fontsize), value = nkRBSetup.bars[barIndex].fontsize, range = {10, 20}, width = 100, 
																						anchors = {{from = "TOPLEFT", object = frame.labelText:getElement(), to = "BOTTOMLEFT", x=350, y=5}}, labelwidth = 174, template =nkRebuff.Config.cbTemplate, 
																						func = function(this) nkRBSetup.bars[barIndex].fontsize = math.floor(this.value*10)/10; this:update({ text = nkRebuff.langTexts.barSettings.slFontSize .. ' ' .. tostring(nkRBSetup.bars[barIndex].fontsize) }) end })
		
	frame.selColorLabelLabel = UI.CreateFrame ('nkExtText', 'selColorDebuffLabel', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame.selLabelLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 4 }}, text = nkRebuff.langTexts.barSettings.rbColorLabel, template = nkRebuff.Config.textTemplate })
	frame.selColorLabel = UI.CreateFrame('nkExtCombo', 'selColorDebuff', frame:getElement(), { layer = 1, value = nkRBSetup.bars[barIndex].lcolor, selection = nkRebuff.langTexts.barSettings.colorSelection, 
																								anchors = {{from = "CENTERLEFT", object = frame.selColorLabelLabel:getElement(), to = "CENTERLEFT", x = 178, y = 0 }}, template =nkRebuff.Config.comboTemplate, 
																								func = function (value) nkRBSetup.bars[barIndex].lcolor = value end})
	
	
	if barIndex == nkRebuff.const.barWarningsID or barIndex == nkRebuff.const.barDebuffsPlayerID or barIndex == nkRebuff.const.barAbilitiesID then
		frame.slRunoutDuration:SetVisible(false)
	end
	
	if barIndex == nkRebuff.const.barWarningsID or barIndex == nkRebuff.const.barAbilitiesID then
		frame.cbInteract:SetVisible(false)
	end
	
	return frame

 end
 
function nkRebuff.Config:setupTabSettings_Track (frame)

	if nkTools.various.getSystemVersion() == '109' then Command.System.Watchdog.Quiet() end

	frame.gridBG = UI.CreateFrame('nkExtTexture', 'nkRBSetupTabPaneTrackGridBG', frame:getElement(), { type = 'nkRebuff', path = "gfx/gridBG.png", width = 705, height = 360, anchors = {{ from = "BOTTOMRIGHT", object = frame:getElement(), to = "BOTTOMRIGHT", x = -4, y = -7 }} })
	
	local mouseOverFunc = function (row)
		local counter = frame.grid:getCounter() + row - 1
		local key = frame.grid:getKey (counter)		
		if key ~= nil then
			self:createTooltipTrack(frame.grid.element.layoutRows[row][1], key, frame.selSetting:getValue())	
			self.tooltipRow = row
		end
	end
	
	local mouseOutFunc = function (row)
		if self.tooltipRow == row then
			self:hideTooltip()
			self.tooltipRow = nil
		end
	end
		
	frame.grid = UI.CreateFrame('nkExtGrid', 'nkRebuffGrid', frame.gridBG:getElement(), {	wheelFunc = function(counter) frame.slider:SetValue (counter) end, fontsize = 13, color = { headerBody = '', headerLabel = 'ECE4BD', label = 'FFFFFF', border = '000000', body = '222222', bodyhighlight = 'FFFFFF', labelhighlight = '000000'}, 
																					anchors = {{ from = 'TOPLEFT', object = frame.gridBG:getElement(true), to = "TOPLEFT", x = 11, y = 0}}, mouseOverFunc = mouseOverFunc, mouseOutFunc = mouseOutFunc })
	frame.grid:getElement():SetLayer(1)
	
	local cols = {	{ header = nkRebuff.langTexts.trackSettings.headerSort, width = 20 }, 
					{ align = 'center', texture = true, type = 'Rift', path = 'gfx/icondummy.png', width = 30, textureWidth = 17, textureHeight = 17}, 
					{ align = 'left', header = nkRebuff.langTexts.trackSettings.headerDescription, width = 273 }, 
					{ header = nkRebuff.langTexts.trackSettings.headerStatus, width = 100 }, 
					{ header = nkRebuff.langTexts.trackSettings.headerAdvanced, width = 150 }, 
					{ header = nkRebuff.langTexts.trackSettings.headerCastBy, width = 100 }}	
	

	frame.slider = UI.CreateFrame('nkExtScrollBox', 'nkRebuffGridSlider', frame:getElement(), { visible = false, value = 1, color = { body = '222222', border = '000000' }, height = 320, anchors = {{ from = "TOPRIGHT", object = frame.gridBG:getElement(false), to = "TOPRIGHT", x = -4, y = 25}}, range = {1, 1},
																								func = function (slider) frame.grid:setPos( math.floor(slider.value) ) end })
	frame.slider:getElement():SetLayer(1)	
		
	frame.selSettingLabel = UI.CreateFrame ('nkExtText', 'selSetting', frame:getElement(), { anchors = {{from = "TOPLEFT", object = frame:getElement(true), to = "TOPLEFT", x = 10, y = 10 }}, text = nkRebuff.langTexts.trackSettings.selSetting, template = nkRebuff.Config.textTemplate })
	
	local activateSettings = function (value)
		frame.cbUseableOnly:SetVisible(true)
		if value == 1 then
			self:PopulateGrid(frame, 'buffdura', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 2 then
			self:PopulateGrid(frame, 'buffperma', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 3 then
			self:PopulateGrid(frame, 'buffother', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 4 then
			frame.cbUseableOnly:SetVisible(false)
			self:PopulateGrid(frame, 'buff3rd', frame.cbActiveOnly:getChecked(), false)
		elseif value == 5 then
			self:PopulateGrid(frame, 'debuff', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 6 then
			self:PopulateGrid(frame, 'cooldowns', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		elseif value == 7 then
			frame.cbUseableOnly:SetVisible(false)
			self:PopulateGrid(frame, 'debuff3rd', frame.cbActiveOnly:getChecked(), false)
		elseif value == 8 then
			frame.cbUseableOnly:SetVisible(true)
			self:PopulateGrid(frame, 'buffTarget', frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())
		end
	end
	
	frame.selSetting = UI.CreateFrame('nkExtCombo', 'selSetting', frame:getElement(), { value = 1, selection = nkRebuff.langTexts.trackSettings.settingSelection, anchors = {{from = "TOPLEFT", object = frame.selSettingLabel:getElement(), to = "TOPLEFT", x = 80, y = 0 }}, width = 250, func = function (value) activateSettings(value) end, template = nkRebuff.Config.comboTemplate})
	frame.selSetting:getElement():SetLayer(2)
	
	frame.fldSearch = UI.CreateFrame ('nkExtTextField', 'searchAbility', frame:getElement(), { value = '', label = nkRebuff.langTexts.trackSettings.lblSearch, anchors = {{ from = "CENTERLEFT", object = frame.selSetting:getElement(), to = "CENTERRIGHT", x = 20, y = 1 }}, labelwidth = 50, width = 150, func = function (value) self:searchAbility(frame, value, false) end, template = nkRebuff.Config.fldTemplate})

	frame.iconCancel = UI.CreateFrame('nkExtTexture', 'iconCancel', frame:getElement(), { type = "nkRebuff", path = "gfx/iconCancel.png", width = 15, height = 15, anchors = {{ from = "CENTERLEFT", object = frame.fldSearch:getElement(), to = "CENTERRIGHT", x = 5, y = 0 }},
																							callBack = function() self:searchAbility(frame, '', true) end })

	
	frame.cbUseableOnly = UI.CreateFrame('nkExtCheckbox', 'cbUseable', frame:getElement(), {text = nkRebuff.langTexts.trackSettings.cbUseableOnly, checked = false, labelwidth = 150, 
														anchors = {{from = "TOPRIGHT", object = frame:getElement(), to = "TOPRIGHT", x= -5, y= -28}}, template = nkRebuff.Config.cbTemplate,
														func = function (this) self:Update() end})														
							
	frame.cbActiveOnly = UI.CreateFrame('nkExtCheckbox', 'cbActive', frame:getElement(), {text = nkRebuff.langTexts.trackSettings.cbActiveOnly, checked = false, labelwidth = 150, 
														anchors = {{from = "CENTERRIGHT", object = frame.cbUseableOnly:getElement(), to = "CENTERLEFT", x= -10, y= 0}}, template = nkRebuff.Config.cbTemplate,
														func = function (this) self:Update() end})
							
	frame.grid:SetVisible(false)
	frame.grid:layout (cols, 16, {headerHeight = 25, buildInstant = false, callBack = function () self:PopulateGrid(frame, 'buffdura', false, false); frame.grid:SetVisible(true) end })	
							
	return frame
	
end
 
function nkRebuff.Config:setupTabSettings_DebuffList(frame)

	frame.gridBG = UI.CreateFrame('nkExtTexture', 'nkRBSetupTabPaneTrackGridBG', frame:getElement(), { type = 'nkRebuff', path = "gfx/gridBG.png", width = 705, height = 360, anchors = {{ from = "BOTTOMRIGHT", object = frame:getElement(), to = "BOTTOMRIGHT", x = -4, y = -7 }} })
	
	local mouseOverFunc = function (row)
		local counter = frame.grid:getCounter() + row - 1
		local key = frame.grid:getKey (counter)		
		if key ~= nil then
			self:createTooltipDebuffList(frame.grid.element.layoutRows[row][1], key, 'FF0000')		
			self.tooltipRow = row
		end
	end
	
	local mouseOutFunc = function (row)
		if self.tooltipRow == row then
			self:hideTooltip()
			self.tooltipRow = nil
		end
	end
	
	frame.grid = UI.CreateFrame('nkExtGrid', 'nkRebuffGrid', frame.gridBG:getElement(), {	wheelFunc = function(counter) frame.slider:SetValue (counter) end, fontsize = 13, color = { headerBody = '', headerLabel = 'ECE4BD', label = 'FFFFFF', border = '000000', body = '222222', bodyhighlight = 'FFFFFF', labelhighlight = '000000'}, 
																					anchors = {{ from = 'TOPLEFT', object = frame.gridBG:getElement(true), to = "TOPLEFT", x = 11, y = 0}}, mouseOverFunc = mouseOverFunc, mouseOutFunc = mouseOutFunc })
	frame.grid:getElement():SetLayer(1)
	
	local cols = {	{ align = 'center', texture = true, type = 'Rift', path = 'gfx/icondummy.png', width = 30, textureWidth = 17, textureHeight = 17}, 
					{ align = 'left', header = nkRebuff.langTexts.debuffList.headerDescription, width = 218 }, 
					{ header = nkRebuff.langTexts.debuffList.headerCastBy, width = 200 },
					{ header = nkRebuff.langTexts.debuffList.headerCalling, width = 75 },
					{ header = nkRebuff.langTexts.debuffList.headerLevel, width = 50 },
					{ header = nkRebuff.langTexts.debuffList.headerTagName, width = 100 }
				}
	frame.grid:layout (cols, 16, {headerHeight = 25})

	frame.slider = UI.CreateFrame('nkExtScrollBox', 'nkRebuffGridSlider', frame:getElement(), { visible = false, value = 1, color = { body = '222222', border = '000000' }, height = 320, anchors = {{ from = "TOPRIGHT", object = frame.gridBG:getElement(false), to = "TOPRIGHT", x = -4, y = 25}}, range = {1, 1},
																								func = function (slider) frame.grid:setPos( math.floor(slider.value) ) end })
	frame.slider:getElement():SetLayer(1)

	frame.closeButton = UI.CreateFrame ('nkExtRiftButton', 'debufListFrameButtonClear', frame:getElement(), { label = nkRebuff.langTexts.debuffList.btClear, anchors = {{from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x = 10, y = 2}}, func = function () nkRebuff.privateVars.lastDebuffs = {}; self:PopulateDebuffListGrid(frame) end})	
	frame.updateButton = UI.CreateFrame ('nkExtRiftButton', 'debufListFrameButtonUpdate', frame:getElement(), { label = nkRebuff.langTexts.debuffList.btRefresh, anchors = {{from = "CENTERLEFT", object = frame.closeButton:getElement(), to = "CENTERRIGHT", x = 10, y = 0}}, func = function () self:PopulateDebuffListGrid(frame) end})	
	
	frame.grid:SetVisible(false)
	frame.grid:layout (cols, 16, {headerHeight = 25, buildInstant = false, callBack = function () self:PopulateDebuffListGrid(frame); frame.grid:SetVisible(true) end })	
	
	return frame

end 
 
function nkRebuff.Config:SetupTabAbout()

	local frame = self.frame.paneTabAbout
	frame:update ({ anchors = {{ from = "TOPLEFT", object = self.frame.tabPane:getBody(), to = "TOPLEFT" }, { from = "BOTTOMRIGHT", object = self.frame.tabPane:getBody(), to = "BOTTOMRIGHT"} } })

	frame.addonNameShadow = UI.CreateFrame ('nkExtText', 'addonNameShadow', frame:getElement(), { layer = 1, text = string.format(nkRebuff.langTexts.about.addonName, nkRebuff.privateVars.addonName), fontsize = 30, color = '000000', anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "TOPCENTER", x = 2, y = 42 }} })
	frame.addonName = UI.CreateFrame ('nkExtText', 'addonName', frame:getElement(), { layer = 2, text = string.format(nkRebuff.langTexts.about.addonName, nkRebuff.privateVars.addonName), fontsize = 30, color = 'E7C878', anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "TOPCENTER", x = 0, y = 40 }} })
	
	frame.versionShadow = UI.CreateFrame ('nkExtText', 'versionShadow', frame:getElement(), { layer = 1, text = string.format(nkRebuff.langTexts.about.version, nkRebuff.privateVars.addonVersion), fontsize = 18, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.addonName:getElement(), to = "BOTTOMCENTER", x = 2, y = 2 }} })
	frame.version = UI.CreateFrame ('nkExtText', 'version', frame:getElement(), { layer = 2, text = string.format(nkRebuff.langTexts.about.version, nkRebuff.privateVars.addonVersion), fontsize = 18, color = 'E7C878', anchors = {{ from = "TOPCENTER", object = frame.addonName:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })

	frame.writtenBy = UI.CreateFrame ('nkExtText', 'writteBy', frame:getElement(), { layer = 1, text = nkRebuff.langTexts.about.writtenBy, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.version:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} })
	frame.patches = UI.CreateFrame ('nkExtText', 'patchCD', frame:getElement(), { layer = 1, text = nkRebuff.langTexts.about.patchCD .. ', ' .. nkRebuff.langTexts.about.patchDebuff, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.writtenBy:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })
	frame.russian = UI.CreateFrame ('nkExtText', 'russian', frame:getElement(), { layer = 1, text = nkRebuff.langTexts.about.russian, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.patches:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} }) 	
	
	frame.copyright = UI.CreateFrame ('nkExtText', 'copyright', frame:getElement(), { layer = 1, text = nkRebuff.langTexts.about.copyright, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.russian:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} })
	
	frame.donate1Shadow = UI.CreateFrame ('nkExtText', 'donate1Shadow', frame:getElement(), { layer = 1, text = nkRebuff.langTexts.about.donate1, fontsize = 20, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.copyright:getElement(), to = "BOTTOMCENTER", x = 2, y = 22 }} })
	frame.donate1 = UI.CreateFrame ('nkExtText', 'donate1', frame:getElement(), { layer = 2, text = nkRebuff.langTexts.about.donate1, fontsize = 20, color = 'E7C878', anchors = {{ from = "TOPCENTER", object = frame.copyright:getElement(), to = "BOTTOMCENTER", x = 0, y = 20 }} })
	
	frame.donate2Shadow = UI.CreateFrame ('nkExtText', 'donate2Shadow', frame:getElement(), { layer = 1, text = nkRebuff.langTexts.about.donate2, fontsize = 20, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.donate1:getElement(), to = "BOTTOMCENTER", x = 2, y = 2 }} })
	frame.donate2 = UI.CreateFrame ('nkExtText', 'donate2', frame:getElement(), { layer = 2, text = nkRebuff.langTexts.about.donate2, fontsize = 20, color = 'E7C878', anchors = {{ from = "TOPCENTER", object = frame.donate1:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })

	frame.twitter = UI.CreateFrame ('nkExtText', 'twitter', frame:getElement(), { layer = 1, text = nkRebuff.langTexts.about.twitter, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.donate2:getElement(), to = "BOTTOMCENTER", x = 0, y = 20 }} })		

end

-- grid handling

function nkRebuff.Config:HandleBuff (row, buffName)
	local frame = self.frame.paneTabSettings.paneTrack
	local curStatus = nkRBSetup.sets[nkRBSetup.basic.activeSet].buff[buffName].active
	if curStatus == false then
		nkRBSetup.sets[nkRBSetup.basic.activeSet].buff[buffName].active = true
		frame.grid.values[frame.grid.counter + row - 1][4].value = nkRebuff.langTexts.trackSettings.txtActive
	else
		nkRBSetup.sets[nkRBSetup.basic.activeSet].buff[buffName].active = false
		frame.grid.values[frame.grid.counter + row - 1][4].value = ''
	end
	frame.grid:fill()
end

function nkRebuff.Config:HandleBuffTarget (row, buffName)
	local frame = self.frame.paneTabSettings.paneTrack
	local curStatus = nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget[buffName].active
	if curStatus == false then
		nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget[buffName].active = true
		frame.grid.values[frame.grid.counter + row - 1][4].value = nkRebuff.langTexts.trackSettings.txtActive
	else
		nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget[buffName].active = false
		frame.grid.values[frame.grid.counter + row - 1][4].value = ''
	end
	frame.grid:fill()
end

function nkRebuff.Config:HandleBuff3rd (row, buffName)
	local frame = self.frame.paneTabSettings.paneTrack
	local curStatus = nkRBSetup.sets[nkRBSetup.basic.activeSet].buff3rd[buffName].active
	if curStatus == false then
		nkRBSetup.sets[nkRBSetup.basic.activeSet].buff3rd[buffName].active = true
		frame.grid.values[frame.grid.counter + row - 1][4].value = nkRebuff.langTexts.trackSettings.txtActive
	else
		nkRBSetup.sets[nkRBSetup.basic.activeSet].buff3rd[buffName].active = false
		frame.grid.values[frame.grid.counter + row - 1][4].value = ''
	end
	frame.grid:fill()
end

function nkRebuff.Config:HandleDebuff3rd (row, buffName)
	local frame = self.frame.paneTabSettings.paneTrack
	local curStatus = nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff3rd[buffName].active
	if curStatus == false then
		nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff3rd[buffName].active = true
		frame.grid.values[frame.grid.counter + row - 1][4].value = nkRebuff.langTexts.trackSettings.txtActive
	else
		nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff3rd[buffName].active = false
		frame.grid.values[frame.grid.counter + row - 1][4].value = ''
	end
	frame.grid:fill()
end

function nkRebuff.Config:HandleCooldowns (row, buffName)

	local frame = self.frame.paneTabSettings.paneTrack
	local curStatus = nkRBSetup.sets[nkRBSetup.basic.activeSet].CD[buffName].active
	if curStatus == false then
		nkRBSetup.sets[nkRBSetup.basic.activeSet].CD[buffName].active = true
		frame.grid.values[frame.grid.counter + row - 1][4].value = nkRebuff.langTexts.trackSettings.txtActive
	else
		nkRBSetup.sets[nkRBSetup.basic.activeSet].CD[buffName].active = false
		frame.grid.values[frame.grid.counter + row - 1][4].value = ''
	end
	frame.grid:fill()

end

function nkRebuff.Config:HandleDebuff (row, buffName)
	local frame = self.frame.paneTabSettings.paneTrack
	local curStatus = nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff[buffName].active
	if curStatus == false then
		nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff[buffName].active = true
		frame.grid.values[frame.grid.counter + row - 1][4].value = nkRebuff.langTexts.trackSettings.txtActive
	else
		nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff[buffName].active = false
		frame.grid.values[frame.grid.counter + row - 1][4].value = ''
	end
	frame.grid:fill()
end

function nkRebuff.Config:PopulateGrid (frame, buffType, showActiveOnly, showOnlyCurrentRole)

	local setInfo = nil
	local abilityData = nil

	if buffType == 'debuff' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff
		abilityData = nkRBSetup.data.debuff
	elseif buffType == 'buff3rd' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].buff3rd
		abilityData = nkRBSetup.data.buff3rd
	elseif buffType == 'debuff3rd' then		
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff3rd
		abilityData = nkRBSetup.data.debuff3rd
	elseif buffType == 'cooldowns' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].CD
		abilityData = nkRBSetup.data.CD
	elseif buffType == 'buffTarget' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget
		abilityData = nkRBSetup.data.buff
	else
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].buff
		abilityData = nkRBSetup.data.buff
	end		
	
	local tempData = {}
	
	if showOnlyCurrentRole == true then
		for k, v in pairs (abilityData) do		
			if v.ability == nil then
				tempData[k] = v
			else
				local abilityInfo = Inspect.Ability.New.Detail(v.ability)
				if abilityInfo ~= nil and abilityInfo.unusable ~= true then tempData[k] = v end
			end
		end
	else
		tempData = abilityData
	end
	
	local sortedKeys = nkTools.table.getSortedKeys(tempData)
	
	local gridValues = {}
	
	-- nkRebuff.privateVars.mainLog:logMessage ('buffType: ' .. buffType, nkLog.levelInfo)
	
	for idx = 1, #sortedKeys, 1 do
		local buffName = sortedKeys[idx]
		if setInfo[buffName] == nil then 
			setInfo[buffName] = {}
			setInfo[buffName].stackType = 0
			setInfo[buffName].stackCount = 0
			setInfo[buffName].sortPrio = 10
			setInfo[buffName].nat = false
			setInfo[buffName].dnw = false
			setInfo[buffName].nms = false
			setInfo[buffName].sco = false
			setInfo[buffName].customRemaining = false
			setInfo[buffName].runoutDuration = nil
			setInfo[buffName].active = false 
		end
		
		if showActiveOnly == false or setInfo[buffName].active == true then
			local showFlag = false

			if buffType == 'debuff' or buffType == 'cooldowns' or buffType == 'buff3rd' or buffType == 'debuff3rd' then
				showFlag = true
			else
				local buffDetail = nkRBSetup.data.buff[buffName]		

				if buffType == 'buffother' and buffDetail.ability == nil then
					if buffDetail.hidden ~= true then showFlag = true end
				elseif buffType == 'buffdura' and buffDetail.duration ~= nil and buffDetail.ability ~= nil then
					if buffDetail.hidden ~= true then showFlag = true end
				elseif buffType == 'buffperma' and buffDetail.duration == nil then
					if buffDetail.hidden ~= true then showFlag = true end
				elseif buffType == 'buffTarget' and buffDetail.duration ~= nil and buffDetail.ability ~= nil then
					if buffDetail.hidden ~= true then showFlag = true end
				end
			end
			
			if showFlag == true then
				local addInfo = ''
				if buffType == 'buff3rd' then 
					local caster = nkRBSetup.data.buff3rd[buffName].caster
					if caster == nil then caster = 'unknown' end
					addInfo = nkRebuff.langTexts.classes[caster]
				elseif buffType == 'debuff3rd' then 
					
					local caster = nkRBSetup.data.debuff3rd[buffName].caster
				  
					-- nkRebuff.privateVars.mainLog:logMessage (buffName .. ' caster: ' .. tostring(caster), nkLog.levelInfo)
				  
					if caster == nil then caster = 'unknown' end
					addInfo = nkRebuff.langTexts.classes[caster]
				end
				
				local status, advanced = '', ''
				if setInfo[buffName].active == true then status = nkRebuff.langTexts.trackSettings.txtActive end
				if setInfo[buffName].stackType > 0 then
					local condText = '='
					if setInfo[buffName].stackType == 1 then
						condText = '<'
					elseif setInfo[buffName].stackType == 3 then
						condText = '>'
					end
					
					advanced = 'S ' .. condText .. ' ' .. tostring(setInfo[buffName].stackCount)
				end
				
				if setInfo[buffName].customRemaining == true and setInfo[buffName].runoutDuration ~= nil then
					if advanced ~= '' then advanced = advanced .. ', ' end
					advanced = advanced .. string.format ('R < %d', setInfo[buffName].runoutDuration)
				end
				
				if setInfo[buffName].nat == true then
					if advanced ~= '' then advanced = advanced .. ', ' end
					advanced = advanced .. 'NAT'
				end
				
				if setInfo[buffName].dnw == true then
					if advanced ~= '' then advanced = advanced .. ', ' end
					advanced = advanced .. 'NW'
				end
				
				if setInfo[buffName].nms == true then
					if advanced ~= '' then advanced = advanced .. ', ' end
					advanced = advanced .. 'NMS'
				end
				
				if setInfo[buffName].sco == true then
					if advanced ~= '' then advanced = advanced .. ', ' end
					advanced = advanced .. 'SCO'
				end				
				
				if setInfo[buffName].sortPrio == nil then setInfo[buffName].sortPrio = 10 end			
				
				table.insert (gridValues, {{ key = buffName, value = setInfo[buffName].sortPrio}, {value = abilityData[buffName].icon}, {value = buffName}, {value = status}, { value = advanced }, { value = addInfo }})
			end
		end
	end
	
	table.sort (gridValues, function (v1, v2) return tonumber(v1[1].value) < tonumber(v2[1].value) end )
	
	frame.grid.counter = 1
	frame.grid:fill(gridValues)
	frame.grid:setClickEvent ( function (row) 

		if gridValues[row] ~= nil then
			if buffType == 'debuff' then
				self:HandleDebuff (row, gridValues[row + self.frame.paneTabSettings.paneTrack.grid.counter - 1][3].value)
			elseif buffType == 'buff3rd' then
				self:HandleBuff3rd (row, gridValues[row + self.frame.paneTabSettings.paneTrack.grid.counter - 1][3].value)
			elseif buffType == 'debuff3rd' then
				self:HandleDebuff3rd (row, gridValues[row + self.frame.paneTabSettings.paneTrack.grid.counter - 1][3].value)
			elseif buffType == 'cooldowns' then
				self:HandleCooldowns (row, gridValues[row + self.frame.paneTabSettings.paneTrack.grid.counter - 1][3].value)
			elseif buffType == 'buffTarget' then
				self:HandleBuffTarget (row, gridValues[row + self.frame.paneTabSettings.paneTrack.grid.counter - 1][3].value)
			else
				self:HandleBuff (row, gridValues[row + self.frame.paneTabSettings.paneTrack.grid.counter - 1][3].value)
			end
		end
	end)
	
	frame.grid:setClickEvent ( function (row) 
		if gridValues[row] ~= nil then
			if buffType ~= 'debuff3rd' then
				self:advancedSettingsDialog(buffType, row, gridValues[row + self.frame.paneTabSettings.paneTrack.grid.counter - 1][3].value)
			end
		end
	end, true)
	
	if (#gridValues-16) > 0 then
		frame.slider:updateRange ({1, (#gridValues-15)})
		frame.slider:SetVisible(true)
	else
		frame.slider:SetVisible(false)
	end
	
end

function nkRebuff.Config:PopulateDebuffListGrid (frame)
	
	local gridValues = {}

	for k, v in pairs(nkRebuff.privateVars.lastDebuffs) do	
		if v.casterDetails ~= nil then
			table.insert (gridValues, {{key = k, value = v.icon}, {value = v.name}, { value = v.casterDetails.name }, { value = nkRebuff.langTexts.classes[v.casterDetails.calling] }, { value = v.casterDetails.level }, { value = v.casterDetails.tagName } })
		else
			table.insert (gridValues, {{key = k, value = v.icon}, {value = v.name}, { value = '' },  { value = '' }, { value = '' }, { value = '' } })
		end
	end
	
	frame.grid.counter = 1
	frame.grid:fill(gridValues)

	if (#gridValues-16) > 0 then
		frame.slider:updateRange ({1, (#gridValues-15)})
		frame.slider:SetVisible(true)
	else
		frame.slider:SetVisible(false)
	end
	
end

-- set handling

function nkRebuff.Config:updateSetSelection (frame)

	local selection = {}
	
	for idx = 1, #nkRBSetup.sets, 1 do
		table.insert (selection, { label = nkRBSetup.sets[idx].name, value = idx })
	end

	frame.fldSelSet:updateSelection(selection)
	
	frame.fldSelSet:setByValue (nkRBSetup.basic.activeSet)	
	frame.fldSetName:SetVisible(false)
	frame.fldSelSet:SetVisible(true)

end
 
function nkRebuff.Config:addSet()

	local noOfSets = #nkRBSetup.sets
	table.insert(nkRBSetup.sets, { name = string.format(nkRebuff.langTexts.genericSettings.newSetName, (#nkRBSetup.sets+1)), role = 0, buff = {}, buff3rd = {}, debuff = {}, debuff3rd = {}, CD = {}, buffTarget = {} })		
	nkRebuff.activateSet (#nkRBSetup.sets)
	
end

function nkRebuff.Config:removeSet()

	if #nkRBSetup.sets == 1 then 
		self:errDialog (nkRebuff.langTexts.messages.cannotRemoveLastSet)
	else			
		local funcYes = function ()
			table.remove (nkRBSetup.sets, nkRBSetup.basic.activeSet)
			nkRebuff.activateSet(1)
		end
	
		self:confirmDialog (nkRebuff.langTexts.messages.removeCurrentSet, funcYes)
	end
	
end

function nkRebuff.Config:copySet()

	local noOfSets = #nkRBSetup.sets
	local newSet = nkTools.table.copy (nkRBSetup.sets[nkRBSetup.basic.activeSet])
	newSet.name = string.format(nkRebuff.langTexts.genericSettings.copiedSetName, nkRBSetup.sets[nkRBSetup.basic.activeSet].name)
	
	table.insert ( nkRBSetup.sets, newSet)
	nkRebuff.activateSet (#nkRBSetup.sets)

end

function nkRebuff.Config:advancedSettingsDialog (abilityType, gridRow, abilityName)

	local dialog = nkRebuff.UIelements.advSettingsDialog

	if dialog == nil then
		local closeFunc = function () 
			dialog.fldStacksCount:leave()
			dialog:SetVisible(false)			
		end
	
		dialog = UI.CreateFrame ('nkExtRiftWindow', 'configFrame', nkRebuff.UIelements.context, {	layer = 9, width = 400, height = 375, title = abilityName, anchors = {{from = "CENTER", object = UIParent, to = "CENTER"}}, dragable = true, closeable = true, visible = true, closeFunc = function() closeFunc() end})
		
		dialog.slsortPrio = UI.CreateFrame('nkExtSlider', 'slsortPrio', dialog:getBody(true), {	text = string.format (nkRebuff.langTexts.advSettingsDialog.slsortPrioLabel, 10), value = 10, range = {1, 10}, width = 100, 
																								anchors = {{from = "TOPLEFT", object = dialog:getBody(true), to = "TOPLEFT", x = 10, y = 10 }}, template = nkRebuff.Config.cbTemplate,
																								func = function (this) this:update({ text = string.format (nkRebuff.langTexts.advSettingsDialog.slsortPrioLabel, this.value)}) end })
																											
		dialog.stacksLabel = UI.CreateFrame ('nkExtText', 'stacksLabel', dialog:getBody(true), { anchors = {{from = "TOPLEFT", object = dialog.slsortPrio:getElement(), to = "BOTTOMLEFT", x = 0, y = 10 }}, text = nkRebuff.langTexts.advSettingsDialog.stacksLabel, template = nkRebuff.Config.textTemplate })
		dialog.selStacksCond = UI.CreateFrame('nkExtCombo', 'selStacksCond', dialog:getBody(true), {	layer = 3, value = 1, width = 125, template = nkRebuff.Config.comboTemplate, selection = nkRebuff.langTexts.advSettingsDialog.selectStacksCondition,
																										anchors = {{ from = "CENTERLEFT", object = dialog.stacksLabel:getElement(), to = "CENTERLEFT", x = 180, y = 0 }} })
		dialog.fldStacksCount = UI.CreateFrame ('nkExtTextField', 'fldSetName', dialog:getBody(true), {	layer = 2, label = nkRebuff.langTexts.advSettingsDialog.stacksCount, func = function () end, labelwidth = 175, width = 50, value = 0, anchors = {{ from = "TOPLEFT", object = dialog.stacksLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }}, template = nkRebuff.Config.fldTemplate})		

		dialog.cbCustomRemaining = UI.CreateFrame('nkExtCheckbox', 'cbCustomRemaining', dialog:getBody(true), {	text = nkRebuff.langTexts.advSettingsDialog.cbCustomRemaining, checked = false,
																						anchors = {{from = "TOPLEFT", object = dialog.fldStacksCount:GetLabel(), to = "BOTTOMLEFT", x = 0, y = 5}}, template = nkRebuff.Config.cbTemplate })
		
		dialog.slRunoutDuration = UI.CreateFrame('nkExtSlider', 'slRunOutDuration', dialog:getBody(true), {text = string.format (nkRebuff.langTexts.advSettingsDialog.slRunoutDuration, 0), value = 0, range = {0, 60}, width = 100, 
																											anchors = {{from = "TOPLEFT", object = dialog.cbCustomRemaining:getElement(), to = "BOTTOMLEFT", x=0, y=10}}, template = nkRebuff.Config.cbTemplate,
																											func = function (this) this:update({ text = string.format (nkRebuff.langTexts.advSettingsDialog.slRunoutDuration, this.value)}) end })
		
		dialog.cbNoWarning = UI.CreateFrame('nkExtCheckbox', 'cbNoWarning', dialog:getBody(true), {	text = nkRebuff.langTexts.advSettingsDialog.cbNoWarning, checked = false,
																											anchors = {{from = "TOPLEFT", object = dialog.slRunoutDuration:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template = nkRebuff.Config.cbTemplate })
																											
		dialog.cbDoNotShowMissing = UI.CreateFrame('nkExtCheckbox', 'cbNoWarning', dialog:getBody(true), {	text = nkRebuff.langTexts.advSettingsDialog.cbDoNotShowMissing, checked = false,
																											anchors = {{from = "TOPLEFT", object = dialog.cbNoWarning:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template = nkRebuff.Config.cbTemplate })
		
		dialog.cbCombatOnly = UI.CreateFrame('nkExtCheckbox', 'cbNoWarning', dialog:getBody(true), {	text = nkRebuff.langTexts.advSettingsDialog.cbCombatOnly, checked = false,
																											anchors = {{from = "TOPLEFT", object = dialog.cbDoNotShowMissing:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template = nkRebuff.Config.cbTemplate })
				
		dialog.cbNoActivityTracking = UI.CreateFrame('nkExtCheckbox', 'cbNoActivityTracking', dialog:getBody(true), {	text = nkRebuff.langTexts.advSettingsDialog.cbNoActivityTracking, checked = false,
																						anchors = {{from = "TOPLEFT", object = dialog.cbCombatOnly:getElement(), to = "BOTTOMLEFT", x = 0, y = 10}}, template = nkRebuff.Config.cbTemplate })
		
		dialog.btSave = UI.CreateFrame ('nkExtRiftButton', 'btSave', dialog:getBody(true), { layer = 1, label = nkRebuff.langTexts.advSettingsDialog.btSave, anchors = {{from = "BOTTOMCENTER", object = dialog:getBody(), to = "BOTTOMCENTER", x = 0, y = -10}}, func = function () self:advancedSettingsProcess (dialog, gridRow, abilityType, abilityName) end})
		
	else
		dialog:update({ title = abilityName })
		dialog:SetVisible(true)		
	end
	
	local setInfo = nil
	
	if abilityType == 'debuff' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff
	elseif abilityType == 'buff3rd' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].buff3rd
	elseif abilityType == 'debuff3rd' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff3rd
	elseif abilityType == 'cooldowns' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].CD
	elseif abilityType == 'buffTarget' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget
	else
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].buff
	end	
	
	dialog.selStacksCond:setByValue(setInfo[abilityName].stackType)
	dialog.fldStacksCount:setValue(setInfo[abilityName].stackCount)
		
	local runoutDuration = setInfo[abilityName].runoutDuration
	
	if runoutDuration == nil then
		if abilityType == 'debuff' then
			runoutDuration = nkRBSetup.bars[nkRebuff.const.barDebuffsID].runoutDuration
		elseif abilityType == 'buffdura' or abilityType == 'buffperma' or abilityType == 'buffother' or abilityType == 'buff3rd' or abilityType == 'buffTarget' then
			runoutDuration = nkRBSetup.bars[nkRebuff.const.barBuffsID].runoutDuration
		elseif abilityType == 'cooldowns' then
			runoutDuration = nkRBSetup.bars[nkRebuff.const.barCooldownsID].runoutDuration
		end
	end
	
	if runoutDuration == nil then
		dialog.cbCustomRemaining:SetVisible(false)
		dialog.slRunoutDuration:SetVisible(false)
	else
		dialog.cbCustomRemaining:SetVisible(true)
		dialog.slRunoutDuration:SetVisible(true)
		
		if setInfo[abilityName].customRemaining ~= nil then dialog.cbCustomRemaining:toggle(setInfo[abilityName].customRemaining) end
		
		dialog.slRunoutDuration:SetValue(runoutDuration)
		dialog.slRunoutDuration:update({ text = string.format (nkRebuff.langTexts.barSettings.slRunoutDuration, runoutDuration)})
	end
	
	if setInfo[abilityName].sortPrio == nil then setInfo[abilityName].sortPrio = 10 end
	dialog.slsortPrio:SetValue(setInfo[abilityName].sortPrio)
	dialog.slsortPrio:update({ text = string.format (nkRebuff.langTexts.advSettingsDialog.slsortPrioLabel, setInfo[abilityName].sortPrio)})

	if setInfo[abilityName].dnw == nil then setInfo[abilityName].dnw = false end
	dialog.cbNoWarning:toggle(setInfo[abilityName].dnw)
	
	if setInfo[abilityName].nms == nil then setInfo[abilityName].nms = false end
	dialog.cbDoNotShowMissing:toggle(setInfo[abilityName].nms)
	
	if setInfo[abilityName].sco == nil then setInfo[abilityName].sco = false end
	dialog.cbCombatOnly:toggle(setInfo[abilityName].sco)
	
	if setInfo[abilityName].nat == nil then setInfo[abilityName].nat = false end
	
	if abilityType == 'cooldowns' then		
		dialog.cbNoActivityTracking:SetVisible(true)
		dialog.cbNoActivityTracking:toggle(setInfo[abilityName].nat)
	else
		dialog.cbNoActivityTracking:SetVisible(false)
	end
	
end

function nkRebuff.Config:advancedSettingsProcess (dialog, gridRow, abilityType, abilityName)

	local setInfo = nil

	if abilityType == 'debuff' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff
	elseif abilityType == 'buff3rd' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].buff3rd
	elseif abilityType == 'debuff3rd' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff3rd
	elseif abilityType == 'cooldowns' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].CD
	elseif abilityType == 'buffTarget' then
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget
	else
		setInfo = nkRBSetup.sets[nkRBSetup.basic.activeSet].buff
	end		
	
	if setInfo[abilityName] == nil then 
		setInfo[abilityName] = {}
		setInfo[abilityName].stackType = 0
		setInfo[abilityName].stackCount = 0
		setInfo[abilityName].customRemaining = false
		setInfo[abilityName].runoutDuration = nil
		setInfo[abilityName].active = false 
				
		setInfo[abilityName].sortPrio = false 
		setInfo[abilityName].nat = false 
		setInfo[abilityName].dnw = false 
		setInfo[abilityName].nms = false 
		setInfo[abilityName].sco = false 
	end
		
	setInfo[abilityName].stackType = dialog.selStacksCond:getValue()
	setInfo[abilityName].stackCount = tonumber(dialog.fldStacksCount:getValue())
	
	if dialog.cbCustomRemaining:IsVisible() == true then
		setInfo[abilityName].customRemaining = dialog.cbCustomRemaining:getChecked()
		if setInfo[abilityName].customRemaining == false then
			setInfo[abilityName].runoutDuration = 0
		else
			setInfo[abilityName].runoutDuration = tonumber(dialog.slRunoutDuration.value)
		end
	end
	
	setInfo[abilityName].dnw = dialog.cbNoWarning:getChecked()
	setInfo[abilityName].nms = dialog.cbDoNotShowMissing:getChecked()
	setInfo[abilityName].sco = dialog.cbCombatOnly:getChecked()
	
	if dialog.cbNoActivityTracking:IsVisible() == true then setInfo[abilityName].nat = dialog.cbNoActivityTracking:getChecked() end
	
	setInfo[abilityName].sortPrio = tonumber(dialog.slsortPrio.value)
	
	dialog.fldStacksCount:leave()
	dialog:SetVisible(false)
	
	local frame = self.frame.paneTabSettings.paneTrack
	
	self:PopulateGrid(frame, abilityType, frame.cbActiveOnly:getChecked(), frame.cbUseableOnly:getChecked())

end

-- move bars

function nkRebuff.Config:Move(lockedFlag)

	if self.frame.paneTabSettings.paneGeneric.cbLocked:getChecked() == true or flag == true then
		nkRebuff.privateVars.barsLocked = true
		nkRebuff.performanceCheck(false)	
		if nkRebuff.UIelements.warningBar ~= nil then nkRebuff.UIelements.warningBar:Moveable( false ) end
		if nkRebuff.UIelements.buffBar ~= nil then nkRebuff.UIelements.buffBar:Moveable( false ) end
		if nkRebuff.UIelements.debuffBar ~= nil then nkRebuff.UIelements.debuffBar:Moveable (false) end
		if nkRebuff.UIelements.cooldownBar ~= nil then nkRebuff.UIelements.cooldownBar:Moveable (false) end
		if nkRebuff.UIelements.activeBar ~= nil then nkRebuff.UIelements.activeBar:Moveable (false) end
		if nkRebuff.UIelements.debuffPlayerBar ~= nil then nkRebuff.UIelements.debuffPlayerBar:Moveable (false) end
		if nkRebuff.UIelements.buffTargetBar ~= nil then nkRebuff.UIelements.buffTargetBar:Moveable (false) end
	else
		nkRebuff.privateVars.barsLocked = false
		nkRebuff.performanceCheck(true)
		nkRebuff.buildBars()
		if nkRebuff.UIelements.warningBar ~= nil then nkRebuff.UIelements.warningBar:Moveable( true ) end
		if nkRebuff.UIelements.buffBar ~= nil then nkRebuff.UIelements.buffBar:Moveable( true ) end
		if nkRebuff.UIelements.debuffBar ~= nil then nkRebuff.UIelements.debuffBar:Moveable (true) end
		if nkRebuff.UIelements.cooldownBar ~= nil then nkRebuff.UIelements.cooldownBar:Moveable (true) end
		if nkRebuff.UIelements.activeBar ~= nil then nkRebuff.UIelements.activeBar:Moveable (true) end
		if nkRebuff.UIelements.debuffPlayerBar ~= nil then nkRebuff.UIelements.debuffPlayerBar:Moveable (true) end
		if nkRebuff.UIelements.buffTargetBar ~= nil then nkRebuff.UIelements.buffTargetBar:Moveable (true) end
	end

end

-- helper functions

function nkRebuff.Config:donateInfo()

	self:messageDialog (nkRebuff.langTexts.about.donate1 .. '\n' .. nkRebuff.langTexts.about.donate2)

end

function nkRebuff.Config:ExportBarSetup() nkRBGlobal.bars = nkTools.table.copy(nkRBSetup.bars) end
function nkRebuff.Config:ImportBarSetup() 

	if nkRBGlobal.bars == nil or #nkRBGlobal.bars == 0 then 
		self:errDialog (nkRebuff.langTexts.messages.msgNoGlobalSettings)
		return 
	end

	local funcYes = function ()
		nkRBSetup.bars = nkTools.table.copy(nkRBGlobal.bars)
		self:Update()
	end

	self:confirmDialog (nkRebuff.langTexts.messages.msgImportBarData, funcYes)

end

function nkRebuff.Config:searchAbility (frame, searchValue, reset)

	frame.fldSearch:leave()
	frame.grid:filter (searchValue, 3, reset)
	
	local gridValues = frame.grid:getValues()
	
	if (#gridValues-21) > 0 then
		frame.slider:updateRange ({1, (#gridValues-20)})
		frame.slider:SetVisible(true)
	else
		frame.slider:SetVisible(false)
	end

end

function nkRebuff.Config:isVisible () return self.frame:isVisible() end

function nkRebuff.Config:udpateTabSettings_Bar(barIndex, frame)	
	
	if frame.slnoOfIcons == nil then return end
		
	frame.slnoOfIcons:SetValue(nkRBSetup.bars[barIndex].noOfIcons)
	frame.slnoOfIcons:update({ text = nkRebuff.langTexts.barSettings.slnoOfIcons .. ' ' .. tostring(nkRBSetup.bars[barIndex].noOfIcons) })

	frame.slRunoutDuration:SetValue(nkRBSetup.bars[barIndex].runoutDuration)
	frame.slRunoutDuration:update({ text = string.format (nkRebuff.langTexts.barSettings.slRunoutDuration, nkRBSetup.bars[barIndex].runoutDuration) })

	frame.cbTooltip:toggle(nkRBSetup.bars[barIndex].tooltip)
	frame.cbInteract:toggle(nkRBSetup.bars[barIndex].hideOnLeftClick)
																
	frame.slScale:SetValue(nkRBSetup.bars[barIndex].scale)
	frame.slScale:update({ text = nkRebuff.langTexts.barSettings.slScale .. ' ' .. tostring(nkRBSetup.bars[barIndex].scale) .. '%' })

	frame.selAlign:setByValue(nkRBSetup.bars[barIndex].align)
	frame.cbFadein:toggle(nkRBSetup.bars[barIndex].cbFadein)

	frame.slAlpha:SetValue(nkRBSetup.bars[barIndex].alpha * 10)
	frame.slAlpha:update({ text = nkRebuff.langTexts.barSettings.slAlpha .. ' ' .. tostring(nkRBSetup.bars[barIndex].alpha) })
	
	frame.selBorder:setByValue(nkRBSetup.bars[barIndex].border)
	frame.selColorBorder:setByValue(nkRBSetup.bars[barIndex].bcolor)
	frame.selColorCounter:setByValue(nkRBSetup.bars[barIndex].ccolor)
	frame.selLabel:setByValue(nkRBSetup.bars[barIndex].label)

	frame.slFontSize:SetValue(nkRBSetup.bars[barIndex].fontsize)
	frame.slFontSize:update({ text = nkRebuff.langTexts.barSettings.slFontSize .. ' ' .. tostring(nkRBSetup.bars[barIndex].fontsize) })

	frame.selColorLabel:setByValue(nkRBSetup.bars[barIndex].lcolor)
	
end

function nkRebuff.Config:ClearData ()

	local funcYes = function ()
		nkRBSetup.data.buff = {}
		nkRBSetup.data.buff3rd = {}
		nkRBSetup.data.debuff = {}
		nkRBSetup.data.debuff3rd = {}
		nkRBSetup.data.CD = {}

		for idx = 1, #nkRBSetup.sets, 1 do
			nkRBSetup.sets[idx].buff = {}
			nkRBSetup.sets[idx].buff3rd = {}
			nkRBSetup.sets[idx].debuff = {}
			nkRBSetup.sets[idx].debuff3rd = {}
			nkRBSetup.sets[idx].CD = {}
		end
		
		nkRebuff.clearTempHides()
		self:Update()
	end

	self:confirmDialog (nkRebuff.langTexts.messages.msgClearAllData, funcYes)
	
end

function nkRebuff.Config:ActivateEvent (flag)

	nkRBSetup.basic.doRecognition = flag

	if not flag or nkRebuff.privateVars.brEventInit then return end

	table.insert(Event.Buff.Add, {nkRebuff.events.BuffAdd , "nkRebuff", "buffAdded"}) 
	table.insert(Event.Ability.Cooldown.Begin, { nkRebuff.events.cooldownBegin, "nkRebuff", "CDBegin"})

end

function nkRebuff.Config:errDialog (message)

	if nkRebuff.UIelements.errDialog == nil then
		nkRebuff.UIelements.errDialog = UI.CreateFrame('nkExtDialog', 'nkRebuffErrDialog', nkRebuff.UIelements.configContext, {	rdesign = true, layer = 2, fontsize = 16, width = 450, height = 150, okButton = true, color = {border = "000000", body = "333333", header = "3B5998", title = "FFFFFF", message = 'FF0000'}, 
																															title = nkRebuff.langTexts.messages.dialogTitle, message = message, anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}} })
	else
		nkRebuff.UIelements.errDialog:update ({ message = message, anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}}, okButton = nil })
		nkRebuff.UIelements.errDialog:SetVisible(true)
	end

end

function nkRebuff.Config:messageDialog (message)

	if nkRebuff.UIelements.messageDialog == nil then
		nkRebuff.UIelements.messageDialog = UI.CreateFrame('nkExtDialog', 'nkRebuffMessageDialog', nkRebuff.UIelements.configContext, {	rdesign = true, layer = 2, fontsize = 16, width = 450, height = 150, okButton = true, color = {border = "000000", body = "333333", header = "3B5998", title = "FFFFFF", message = 'FF0000'}, 
																																		title = nkRebuff.privateVars.addonName, message = message, anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}} })
	else
		nkRebuff.UIelements.messageDialog:update ({ message = message, anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}}, okButton = nil })
		nkRebuff.UIelements.messageDialog:SetVisible(true)
	end

end

function nkRebuff.Config:confirmDialog (message, funcYes)
	
	if nkRebuff.UIelements.confirmDialog == nil then
		nkRebuff.UIelements.confirmDialog = UI.CreateFrame('nkExtDialog', 'nkRebuffConfirmDialog', nkRebuff.UIelements.configContext, { rdesign = true, layer = 2, fontsize = 16, width = 450, height = 150, confirmButton = true, color = {border = "000000", body = "333333", header = "3B5998", title = "FFFFFF", message = 'FFFFFF'}, 
																							title = nkRebuff.privateVars.addonName, message = message, 
																							anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}}, funcYes = funcYes })
	else
		nkRebuff.UIelements.confirmDialog:update ({ message = message, anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}}, funcYes = funcYes })
		nkRebuff.UIelements.confirmDialog:SetVisible(true)
	end

end

function nkRebuff.Config:createTooltipDebuffList(frame, key, color)
	
	local info = nkRebuff.privateVars.lastDebuffs[key]
	
	local desc = ''
	if info.description ~= nil then desc = info.description else		
		if info.ability ~= nil then
			local abilityInfo = Inspect.Ability.New.Detail(info.ability)			
			if abilityInfo ~= nil then desc = abilityInfo.description end
		end
	end
	
	local castBy = ''
	if info.casterDetails ~= nil then
		castBy = string.format(nkRebuff.langTexts.various.castBy, info.casterDetails.name)
	end
		
	nkRebuff.showTooltip(nil, frame:getElement(), info.name, color, desc, castBy)

end

function nkRebuff.Config:createTooltipTrack(frame, key, settingsType)
	
	local color = 'FFFFFF'
	local info = nil
	
	if settingsType == 1 or settingsType == 2 or settingsType == 3 or settingsType == 8 then				
		color = '00FF21'
		info = nkRBSetup.data.buff[key]
	elseif settingsType == 4 then
		color = '00FF21'
		info = nkRBSetup.data.buff3rd[key]
	elseif settingsType == 5 then
		color = 'FF0000'
		info = nkRBSetup.data.debuff[key]
	elseif settingsType == 6 then
		color = '0094FF'
		info = nkRBSetup.data.CD[key]
	elseif settingsType == 7 then
		color = 'FF0000'
		info = nkRBSetup.data.debuff3rd[key]
	end

	if info == nil then return end
	
	if info.ability ~= nil then
		local abilityInfo = Inspect.Ability.New.Detail(info.ability)			
		if abilityInfo ~= nil then
			if info.caster == nil then info.caster = 'player' end
			nkRebuff.showTooltip(nil, frame:getElement(), abilityInfo.name, color, abilityInfo.description, string.format(nkRebuff.langTexts.various.castBy, nkRebuff.langTexts.classes[info.caster]))
		end
	end

end

function nkRebuff.Config:hideTooltip() if nkRebuff.UIelements.tooltip ~= nil then nkRebuff.hideTooltip() end end